var checkBoxes = [];
var kmlLayers = [];
var imgLayers = [];

var markerObjectArray = [];
var map;

var	thumbnailWidth = '300';
var jsonDocUrl = "./records.json";
var	lat = 34.7;
var lng = 135.5;
var	zlv = 13;
 
var jsonMarkers;
var infoWindowContent;
 
function reload()
{
	deleteAllLayers();
	deleteMarkers();
	jsonMarkers.marker.forEach(addMarkers);
	
	resetZoom();
}

function initialize() 
{	var mapOptions = 
	{	zoom: zlv, minZoom: 2, center: new google.maps.LatLng(lat, lng),
		panControl: false, zoomControl: false, scaleControl: true, streetViewControl: false,
		mapTypeControlOptions: 
		{	style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,
			position: google.maps.ControlPosition.TOP_RIGHT			
		}
	};
	map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
	
	jsonMarkers = JSON.parse(httpGet(jsonDocUrl));

	deleteAllLayers();
 	deleteMarkers();
	
	jsonMarkers.marker.forEach(addMarkers);
}

function deleteMarkers() 
{	for (var i = 0; i < markerObjectArray.length; i++) 
	{	markerObjectArray[i].marker.setMap(null);
		markerObjectArray[i].infoWindow.close();
	}
 	 markerObjectArray = [];
}

function deleteAllLayers() 
{	for (var i = 0; i < kmlLayers.length; i++) kmlLayers[i].setMap(null);
  	for (var i = 0; i < checkBoxes.length; i++) checkBoxes[i].checked = false;
	for (var i = 0; i < imgLayers.length; i++) imgLayers[i].setMap(null);
	kmlLayers = [];
	checkBoxes = [];
	imgLayers = [];
}

function checkBoxControl(checkBoxName, checkState)
{	for (var i = 0; i < checkBoxes.length; i++) 
		if(checkBoxes[i].name == checkBoxName) checkBoxes[i].checked = checkState;
}

function deleteLayers(kmlFileName, checkBoxName) 
{	var tmpLayers =[];
	for (var i = 0; i < kmlLayers.length; i++) 
	{	if(kmlLayers[i].getUrl() == kmlFileName) kmlLayers[i].setMap(null);
		else tmpLayers.push(kmlLayers[i]);
	}
	for (var i = 0; i < checkBoxes.length; i++) 
		if(checkBoxes[i].name == checkBoxName) checkBoxes[i].checked = false;
	
	kmlLayers = [];
	kmlLayers = tmpLayers;
	
	if(kmlLayers.length == 0&&imgLayers.length ==0) map.setZoom(zlv);
	else if(imgLayers.length ==0)
		map.fitBounds(kmlLayers[kmlLayers.length - 1].getDefaultViewport());
	else if(klmLayers.length ==0)
		map.fitBounds(imgLayers[imgLayers.length - 1].getDefaultViewport());
}

function resetZoom() 
{	map.setZoom(zlv);
	if(isMobile) 
	{	var myLatlng = new google.maps.LatLng(15.0, 127.378857);  
		map.setCenter(myLatlng);
}	}

function addMarkers(thisMarker,index)
{	
	var title = thisMarker.id;
	infoWindowContent = thisMarker.desc;
		
	if(thisMarker.overLayer)
	{
		if(thisMarker.overLayer.length >1)
			thisMarker.overLayer.forEach(addOverlayer); 
		else
			addOverlayer(thisMarker.overLayer);
	}
	if(thisMarker.mapLayer)
		addOverlayer(thisMarker.mapLayer);
				
	infoWindowContent += '<a href="'+thisMarker.url+'" title="Click to redirect to Flicker!" target="_blank"><br>' +
					 '<img src="' + thisMarker.thumbnail + 
					 '"' +thisMarker.portrait+'=' + thumbnailWidth + '></a>';
	
	var markerObject = new Object();
	markerObject.lat = thisMarker.lat;
	markerObject.lng = thisMarker.lng;
	markerObject.title = thisMarker.id;
	markerObject.infoWindow = new google.maps.InfoWindow({content: infoWindowContent, maxWidth: thumbnailWidth});
	markerObject.location = thisMarker.group;
	markerObject.camera = thisMarker.camera;
	
	renderMarkers(markerObject,(index/2)*50);
}

function addOverlayer(thisLayer)
{
	var funcName;
	if(thisLayer.type.toLowerCase() == "map") 
		funcName = "addMapOverLayer(this);";
	else funcName = "addRouteOverLayer(this);";
				
	var strCheck = "";
				
	infoWindowContent += '<br><input onclick="'+funcName+'" type=checkbox name="'+
						 thisLayer.id +'" value="' + thisLayer.data +'"'+ strCheck+'>';
	if(thisLayer.type.toLowerCase() != "map") 				 
	{	
		infoWindowContent += '<font class="checkbox">' + thisLayer.label+ '</font>'+'</a>';	
	}
	else
	{
		infoWindowContent += '<font class="checkbox">' + thisLayer.label+ '</font>';	
	}
}

function renderMarkers(markerObject, timeout)
{	if(timeout==-1)
	{	markerObject.marker = new google.maps.Marker(	
		{	position: new google.maps.LatLng(markerObject.lat, markerObject.lng), 
			map: map,
			title: markerObject.title, 
			animation: google.maps.Animation.DROP
		});
		markerObjectArray.push(markerObject);
		registerMarkerEventListener(markerObject);
	}
	else
	window.setTimeout(function()
	{	markerObject.marker = new google.maps.Marker(	
		{	position: new google.maps.LatLng(markerObject.lat, markerObject.lng), 
				map: map,
				title: markerObject.title, 
				animation: google.maps.Animation.DROP
		});
		markerObjectArray.push(markerObject);
		registerMarkerEventListener(markerObject);
	}, timeout);
}

//Adding Markers and Layers by Google maps API
function registerMarkerEventListener(markerObject)
{	google.maps.event.addListener(markerObject.marker, 'click', function() 
	{	if(	markerObject.marker.getAnimation() == null)
		{	markerObject.infoWindow.open(map, markerObject.marker);
			markerObject.marker.setAnimation(google.maps.Animation.BOUNCE); 
		}
		else
		{	markerObject.marker.setAnimation(null); 
			markerObject.infoWindow.close();
		}
		for(var i=0; i<markerObjectArray.length;i++)
		{	if(markerObjectArray[i] == markerObject) continue;
			if(!event.ctrlKey && !event.metaKey)
			{	markerObjectArray[i].infoWindow.close();
				markerObjectArray[i].marker.setAnimation(null);
			}
		}			
	}	);
	
	google.maps.event.addListener(markerObject.infoWindow, 'closeclick', function() 
	{	
		markerObject.marker.setAnimation(null);
	}	);
}

function addMapOverLayer(checkBox)
{	if(checkBox.checked) 
	{	for (var i=0; i<jsonMarkers.marker.length; i++)
		{	if(jsonMarkers.marker[i].mapLayer)
			{	var layer = jsonMarkers.marker[i].mapLayer;
				if(checkBox.name == layer.id)
				{	
					var imgBounds = new google.maps.LatLngBounds(
						new google.maps.LatLng(layer.lat1, layer.lng1) ,
						new google.maps.LatLng(layer.lat2, layer.lng2) );
		
					var maplayer = new google.maps.GroundOverlay(
					strUrl + layer.data, imgBounds);
				
					maplayer.setMap(map); map.fitBounds(imgBounds);
					imgLayers.push(maplayer);		
				}
			}
		}
		checkBoxes.push(checkBox);
	}
	else
	{	for(var k=0; k<imgLayers.length; k++){ imgLayers[k].setMap(null);}
		imgLayers = []; 
	}	
}

function addRouteOverLayer(checkBox)
{	if(checkBox.checked) 
	{	var Layer = new google.maps.KmlLayer({url: checkBox.value});
		Layer.setMap(map); 
		kmlLayers.push(Layer);
		checkBoxes.push(checkBox);
	}
	else deleteLayers(checkBox.value, checkBox.name);
}

function httpGet(theUrl)
{
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open( "GET", theUrl, false ); // false for synchronous request
    xmlHttp.send( null );
    return xmlHttp.responseText;
}